# Change Log
CodeTogether is available for VS Code, Eclipse, and IntelliJ providing pair programming services right from a browser.

## [2.1.0] - 2020.8.6
- **Syntax Coloring for Cobol, Dart, and Elixir**  
  Language coloring and completion aides have been added for Cobol, Dart, and Elixir.
- **.codetogether.ignore Allows Hiding Files/Folders**  
  Files or Folders that should not be available in the session can be hidden by creating .codetogether.ignore files in the root of projects using .gitignore like glob patterns.
- **Preview: File Uploads from Browser**  
  Files can be added to the shared project simply by dragging them into the Explorer in the browser.
- **IntelliJ Fixes for Code Alone**  
  In certain scenarios, edits made from the browser would not show up in IntelliJ and related IDEs. This has been rectified.
- **Various General Fixes**  
  Numerous fixes reported including navigation reliability, and exposing Toggle Word Wrap have been addressed.

## [2.0.1] - 2020.7.16
- **Little Fixes Land**  
  In VS Code, certain folders may not have loaded right in the browser. In IntelliJ, editing in markdown files could fail from the browser side. Both are fixed including a couple other small tweaks.
- **On-Premises Base Image**  
  The Docker image used for On-Premises has been migrated to a RedHat UBI base.

## [2.0.0] - 2020.7.6
- **2.0 Has Arrived!**  
  Packed with new features, 2.0 brings an all new experience to remote development!
- **Simultaneous Editing**  
  Highly requested support for editing in multiple files by different people is now available! Even coding in the same file is smoothed out with seamless control change.
- **CodeTogether or Alone**  
  Now you can easily split off from the group to explore or code independently. Working together? Selection is now naturally shared across collaborators.
- **IDE Themes and Key Bindings**  
  Choose to code with your favorite key bindings and IDE looks from IntelliJ, Eclipse and VS Code, regardless of what IDE is being used.
- **On-Premises Ready**  
  Looking for more security? CodeTogether can be deployed behind the firewall for even greater control over source exposure.
- **Quick Fix Support**  
  Building on the new 2.0 base, it is now possible to use Quick Fixes right from the browser using full IDE smarts. More IDE aids are coming!
- **Oodles of Fixes**  
  Dozens of other fixes have landed in this release, from compatibility with more IDEs to coding reliability, and syntax coloring for Twig, Scala and more!

## [1.2.0] - 2020.5.21
- **End-to-End Encryption**  
  All sessions now include full end-to-end encryption! Beyond secure SSL connections between endpoints, end-to-end AES encryption ensures that your source is never exposed, even if our secure servers were somehow exploited.
- **Anonymous Usage**  
  Now you can use CodeTogether sessions without logging in or registering. As CodeTogether is free for all, no need to require logins!
- **Tab Sizes and Spaces**  
  CodeTogether automatically detects tab sizes and space-usage to ensure that while coding in the browser, you always get a consistent and expected experience.
- **IntelliJ Robustness**  
  Jetbrains IDEs support picks up numerous fixes from support for multiple windows, to consistent marker relaying, and improvements in content assist. Thanks for all the reports!
- **Running Behind Proxies**  
  Sessions would sometimes not start correctly when running behind proxies in both Eclipse and IntelliJ. Both hosts have been fixed to work right.
- **Transparency on GitHub**  
  All CodeTogether issues and resolution are now tracked on GitHub Issues. Check out the milestones to see what else was fixed for this release and more.

## [1.1.0] - 2020.4.29
- **Now Available for IntelliJ**  
  CodeTogether is now in early access for IntelliJ! In addition, CodeTogether has been taken out of early access for Eclipse and VS Code. Thanks for all the great feedback!
- **Presence Visualization**  
  Participants and hosts alike can see rich visualization of what others in the session are up to including seeing who is browsing code on their own, recent edit locations and more.
- **Seamlessly Take Control**  
  Participants can now take control by typing. If enabled, typing can be immediate with no dialog or confirmation allowing rapid control changes when working together.
- **Editing Reliability**  
  Numerous fixes have been implemented to ensure reliable coding, from oddities with non-foreground browser windows to timing issues when typing fast.
- **Format Files and Language Smarts**  
  Participants can now choose to remotely format files, using formatting configuration on the host. Language smarts have also been enhanced for multiple Eclipse editors giving better content assist and as-you-type marker validation.
- **Reliability of Content Assistance**  
  When using code completion, characters could get lost if it took a while to complete the content assist action. In addition, key trigger characters are now relayed to the browser making coding more natural.

## [1.0.5] - 2020.4.8
- **Improved Control Visualization**  
  Editors now show who is in control both on the host side and in the browser.
- **Browser-side Light and Dark Themes**  
  Participants can now choose to code in a light or dark theme when working in CodeTogether sessions.
- **Control and Follow Keybindings in Browser**  
  Key bindings now allow changing Control or Follow: use CMD/CTRL-K then C for control, CMD/CTRL-K then F for follow.
- **Update Details**  
  When starting a session, if an optional client update is available, details about the update will be provided.
- **Numerous Fixes**  
  Various other improves have landed including correctly relaying intra-line selection, and more editing consistency.

## [1.0.4] - 2020.3.27
- **Improved Searching**  
  Searching in the workspace now gives consistent results when retriggering searching.
- **Create Files from Browser**  
  Correctly allow new files to be created from the browser.
- **Fixes for Control Changes**  
  Improve consistency when multiple participants take turns controlling.

## [1.0.3] - 2020.3.18
- **Participant Names**  
  Participants can now specify names from the browser when joining sessions.
- **Improves Integrity Checks**  
  When relaying and processing changes, additional integrity checks have been added to ensure editing consistency.

## [1.0.2] - 2020.3.6
- **Fixes Copy/Paste of Session on Linux**  
  Copying the session URL was not working as expected and the library has been changed.

## [1.0.1] - 2020.3.5
- **CodeTogether is Public!**  
  We are happy to announce CodeTogether being generally available and no longer in private trials!
